unit uDizzy;
{
    Dizzy - Digital Simulator
    Copyright (C) 2004 Arne Bochem <dizzy@arneb.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls, StdCtrls, Registry, uBTree, uMovableObject, uGate,
  uGate1O, uGate1I, uGate1I1O, uGate2I1O, uGate5I2O, uGate3I3O, uGate9I5O,
  uGate6I1O, uGate10I4O, uAboutBox, uHelp;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Board: TImage;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Timer1: TTimer;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    N1: TMenuItem;
    Neu1: TMenuItem;
    ffnen1: TMenuItem;
    Speichern1: TMenuItem;
    Speichernunter1: TMenuItem;
    Hilfe1: TMenuItem;
    Bedienung1: TMenuItem;
    N2: TMenuItem;
    Info1: TMenuItem;
    Button15: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer2: TTimer;
    Timer3: TTimer;
    Button16: TButton;
    function getMValue(o : TObject; c : TClass): integer;
    function getNextId : integer;
    function Zero(o : TObject; c : TClass) : Integer;
    procedure Beenden1Click(Sender: TObject);
    procedure groundBoard;
    procedure blitBoard;
    procedure FormCreate(Sender: TObject);
    procedure BoardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BoardMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Neu1Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure Speichernunter1Click(Sender: TObject);
    procedure ffnen1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Bedienung1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button16Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  bufferWidth = 1024;
  bufferHeight = 1024;

var
  Mobs, Queue, PowerLines : TTree;
  MobClass : TMobClass;
  MkPowerLine, Quick : Boolean;
  ClickedMob : TGate;
  ClickedJack : Integer;
  CurrentId : Integer = 0;
  BackgroundImg : TBitmap;
  Overflow : TPoint;
  FileName : TFileName;
  FileHandle : File of Char;

function TForm1.Zero(o : TObject; c : TClass) : Integer;
begin
  result := 0;
end;

function TForm1.getNextId : integer;
begin
  result := CurrentId;
  CurrentId := CurrentId + 1;
end;

function TForm1.getMValue(o : TObject; c : TClass): integer;
var
  m : TGate;
  p : TPowerLine;
begin
  if o is TGate then
    begin
      m := o as TGate;
      result := m.getId;
      exit;
    end;
  p := o as TPowerLine;
  result := p.getId;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.blitBoard;
begin
  Board.Canvas.CopyRect(Rect(0, 0, Board.Width, Board.Height), BackgroundImg.Canvas, Rect(ScrollBar1.Position * (Board.Width div 2) + Overflow.X, ScrollBar2.Position * (Board.Height div 2) + Overflow.Y, ScrollBar1.Position * (Board.Width div 2) + Board.Width + Overflow.X, ScrollBar2.Position * (Board.Height div 2) + Board.Height + Overflow.Y));
end;

procedure TForm1.groundBoard;
var
  Line : Integer;
begin
  BackgroundImg.Canvas.Brush.Color := clWhite;
  BackgroundImg.Canvas.FillRect(Rect(0, 0, BackgroundImg.Width, BackgroundImg.Height));
  BackgroundImg.Canvas.Pen.Color := clLtGray;
  Line := 1;
  while Line * 15 < BackgroundImg.Width do
    begin
      BackgroundImg.Canvas.MoveTo(Line * 15, 0);
      BackgroundImg.Canvas.LineTo(Line * 15, BackgroundImg.Height);
      Line := Line + 1;
    end;
  Line := 1;
  while Line * 15 < BackgroundImg.Height do
    begin
      BackgroundImg.Canvas.MoveTo(0, Line * 15);
      BackgroundImg.Canvas.LineTo(BackgroundImg.Width, Line * 15);
      Line := Line + 1;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := true;
  Mobs := TTree.Create(TGate, getMValue);
  PowerLines := TTree.Create(TPowerLine, getMValue);
  Queue := TTree.Create(TTree, Zero);
  Queue.insertItem(TTree.Create(TGate, getMValue));
  Queue.resetPosition;
  MobClass := TSwitch;
  StatusBar1.SimpleText := 'Aktion: Schalter';
  MkPowerLine := false;
  Overflow.X := 0;
  Overflow.Y := 0;
  Quick := true;
  BackgroundImg := TBitmap.Create;
  BackgroundImg.Width := bufferWidth;
  BackgroundImg.Height := bufferHeight;
  groundBoard;
  blitBoard;
end;

procedure TForm1.BoardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Mob, foundMob : TGate;
  noFound : boolean;
  fakeButton : TMouseButton;
begin
  X := ScrollBar1.Position * (Board.Width div 2) + X + Overflow.X;
  Y := ScrollBar2.Position * (Board.Height div 2) + Y + Overflow.Y;
  noFound := true;
  Mob := Mobs.resetPosition as TGate;
  foundMob := nil;
  groundBoard;
  fakeButton := Button;
  if Button = mbRight then fakeButton := mbMiddle;
  while Mob <> nil do
    begin
      if Mob.targetMouseEvent(x, y, fakeButton, 0) then
        begin
          noFound := false;
          foundMob := Mob;
        end;
      Mob.blitToCanvas;
      Mob := Mobs.getNext as TGate;
    end;
  if Not(noFound) and (foundMob <> nil) and (Button = mbRight) then
    begin
      foundMob.targetMouseEvent(x, y, Button, 0);
      groundBoard;
      Mob := Mobs.resetPosition as TGate;
      while Mob <> nil do
        begin
          Mob.blitToCanvas;
          Mob := Mobs.getNext as TGate;
        end;
    end;
  blitBoard;
end;

procedure TForm1.BoardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Mob : TGate;
  Coords : TPoint;
begin
  X := ScrollBar1.Position * (Board.Width div 2) + X + Overflow.X;
  Y := ScrollBar2.Position * (Board.Height div 2) + Y + Overflow.Y;
  Mob := Mobs.resetPosition as TGate;
  groundBoard;
  while Mob <> nil do
    begin
      Mob.targetMouseEvent(x, y, mbMiddle, 1);
      Mob.blitToCanvas;
      Mob := Mobs.getNext as TGate;
    end;
  if MkPowerLine then
    begin
      BackgroundImg.Canvas.Pen.Color := clBlack;
      Coords := ClickedMob.getOutputCoords(ClickedJack);
      BackgroundImg.Canvas.MoveTo(Coords.X, Coords.Y);
      BackgroundImg.Canvas.LineTo(X, Y);
    end;
  blitBoard;
end;

procedure TForm1.BoardMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Mob, foundMob : TGate;
  noFound : boolean;
  Sections : TClickSections;
begin
  X := ScrollBar1.Position * (Board.Width div 2) + X + Overflow.X;
  Y := ScrollBar2.Position * (Board.Height div 2) + Y + Overflow.Y;
  noFound := true;
  Mob := Mobs.resetPosition as TGate;
  foundMob := nil;
  groundBoard;
  while Mob <> nil do
    begin
      if Mob.targetMouseEvent(x, y, Button, 2) then
        begin
          noFound := false;
          foundMob := Mob;
          Sections := Mob.getClickedSection(x, y);
          if MkPowerLine and (Button = mbLeft) and (Sections.Input > 0) and Mob.emptyJack(Sections.Input) then
            begin
              MkPowerLine := false;
              PowerLines.insertItem(TPowerLine.Create(ClickedJack, ClickedMob, Sections.Input, Mob, BackgroundImg.Canvas, getNextId(), Queue, PowerLines));
            end
          else if Not(MkPowerLine) and (Button = mbLeft) and (Sections.Input > 0) and Not(Mob.emptyJack(Sections.Input)) then
            Mob.destroyConnection(Sections.Input);
        end;
      Mob.blitToCanvas;
      Mob := Mobs.getNext as TGate;
    end;
  if noFound and (Button = mbLeft) and (MobClass <> nil) then
    Mobs.insertItem(MobClass.Init(x, y, BackgroundImg.Canvas, getNextId()));
  if Not(noFound) and (foundMob <> nil) and (Button = mbLeft) then
    begin
      if MobClass <> nil then
        begin
          Sections := foundMob.getClickedSection(x, y);
          if (MobClass <> nil) and (Sections.Output > 0) and (Button = mbLeft) then
            begin
              MkPowerLine := Not(MkPowerLine);
              ClickedMob := foundMob;
              ClickedJack := Sections.Output;
            end;
        end
      else
        begin
          Mobs.getByValue(foundMob.getId);
          Mobs.deleteItem;
          foundMob.Destroy;
          groundBoard;
          Mob := Mobs.resetPosition as TGate;
          while Mob <> nil do
            begin
              Mob.blitToCanvas;
              Mob := Mobs.getNext as TGate;
            end;
        end;
    end;
  blitBoard;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Overflow.X := 1024 - (ScrollBar1.Position * (Board.Width div 2) + Board.Width);
  if Overflow.X >= 0 then Overflow.X := 0;
  blitBoard;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  Overflow.Y := 1024 - (ScrollBar2.Position * (Board.Height div 2) + Board.Height);
  if Overflow.Y >= 0 then Overflow.Y := 0;
  blitBoard;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  blitBoard;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Schalter';
  MobClass := TSwitch;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: LED';
  MobClass := TLED;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Not';
  MobClass := TNot;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: And';
  MobClass := TAnd;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Or';
  MobClass := TOr;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Nand';
  MobClass := TNand;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Nor';
  MobClass := TNor;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Xor';
  MobClass := TXor;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Taktgeber';
  MobClass := TSignalPulse;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: JK-MS-Flipflop';
  MobClass := TFlipflop;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: 1-Bit-Volladdierer';
  MobClass := TOneBitFullAdder;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: 4-Bit-Volladdierer';
  MobClass := TFourBitFullAdder;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: Entfernen';
  MobClass := nil;
  MkPowerLine := false;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: 4 zu 1 Multiplexer';
  MobClass := T41Multiplexer;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  StatusBar1.SimpleText := 'Aktion: 16x4-Bit-RAM';
  MobClass := T4bRAM;
end;

procedure TForm1.Neu1Click(Sender: TObject);
begin
  Speichern1.Enabled := false;
  Caption := 'Dizzy - Digital Simulator';
  Mobs.Destroy;
  Mobs := TTree.Create(TGate, getMValue);
  PowerLines.Destroy;
  PowerLines := TTree.Create(TPowerLine, getMValue);
  Queue.Destroy;
  Queue := TTree.Create(TTree, Zero);
  Queue.insertItem(TTree.Create(TGate, getMValue));
  Queue.resetPosition;
  MobClass := TSwitch;
  CurrentId := 0;
  StatusBar1.SimpleText := 'Aktion: Schalter';
  MkPowerLine := false;
  groundBoard;
  blitBoard;
end;

procedure TForm1.Speichern1Click(Sender: TObject);
var
  Mob : TGate;
  DataString, MobDataString, MobString, PLDataString : String;
  j : Integer;
begin
  MobDataString := '';
  PLDataString := '';
  Mob := Mobs.resetPosition as TGate;
  while Mob <> nil do
    begin
      if Mob is TSwitch then MobDataString := MobDataString + '0';
      if Mob is TSignalPulse then MobDataString := MobDataString + '1';
      if Mob is TLED then MobDataString := MobDataString + '2';
      if Mob is TNot then MobDataString := MobDataString + '3';
      if Mob is TNand then MobDataString := MobDataString + '4';
      if Mob is TNor then MobDataString := MobDataString + '5';
      if Mob is TAnd then MobDataString := MobDataString + '6';
      if Mob is TOr then MobDataString := MobDataString + '7';
      if Mob is TXor then MobDataString := MobDataString + '8';
      if Mob is TOneBitFullAdder then MobDataString := MobDataString + '9';
      if Mob is TFlipFlop then MobDataString := MobDataString + '10';
      if Mob is T41Multiplexer then MobDataString := MobDataString + '11';
      if Mob is TFourBitFullAdder then MobDataString := MobDataString + '12';
      if Mob is T4bRAM then MobDataString := MobDataString + '13';
      MobString := Mob.getDataString;
      if Pos('|', MobString) > 0 then
        begin
          PLDataString := PLDataString + ';' + Copy(MobString, Pos('|', MobString) + 1, Length(MobString) - Pos('|', MobString) + 1);
          Delete(MobString, Pos('|', MobString), Length(MobString) - Pos('|', MobString) + 1);
        end;
      MobDataString := MobDataString + MobString;
      Mob := Mobs.getNext as TGate;
      if (MobDataString <> '') then
        if (Mob <> nil) then
          MobDataString := MobDataString + ';'
        else
          MobDataString := MobDataString + '|';
    end;
  if PLDataString <> '' then Delete(PLDataString, 1, 1);
  DataString := MobDataString + PLDataString;
  Rewrite(FileHandle);
  for j := 1 to Length(DataString) do
    Write(FileHandle, DataString[j]);
  CloseFile(FileHandle);
end;

procedure TForm1.Speichernunter1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    begin
      Speichern1.Enabled := true;
      FileName := SaveDialog1.FileName;
      Caption := FileName + ' - Dizzy - Digital Simulator';
      AssignFile(FileHandle, FileName);
      Speichern1Click(Sender);
    end;
end;

procedure TForm1.ffnen1Click(Sender: TObject);
var
  EndOfSection, Id, NS, ND, MaxId : Integer;
  c : Char;
  LoaderMobClass : TMobClass;
  S, D : TGate;
  Value : Boolean;
  MobDataString, PLDataString, SubDataString : String;
begin
  if OpenDialog1.Execute then
    begin
      Neu1Click(Sender);
      Speichern1.Enabled := true;
      FileName := OpenDialog1.FileName;
      Caption := FileName + ' - Dizzy - Digital Simulator';
      AssignFile(FileHandle, FileName);
    end
  else
    exit;
  PLDataString := '';
  MaxId := 0;
  Reset(FileHandle);
  while Not(Eof(FileHandle)) do
    begin
      Read(FileHandle, c);
      PLDataString := PLDataString + c;
    end;
  CloseFile(FileHandle);
  if Pos('|', PLDataString) > 0 then
    EndOfSection := Pos('|', PLDataString)
  else
    begin
      PLDataString := PLDataString + '|';
      EndOfSection := Length(PLDataString);
    end;
  MobDataString := Copy(PLDataString, 1, EndOfSection - 1);
  Delete(PLDataString, 1, EndOfSection);
  while MobDataString <> '' do
    begin
      if Pos(';', MobDataString) > 0 then
        EndOfSection := Pos(';', MobDataString)
      else
        begin
          MobDataString := MobDataString + ';';
          EndOfSection := Length(MobDataString);
        end;
      SubDataString := Copy(MobDataString, 1, EndOfSection - 1);
      Delete(MobDataString, 1, EndOfSection);
      Id := StrToInt(Copy(SubDataString, 1, Pos(':', SubDataString) - 1));
      if Id >= MaxId then
        MaxId := Id + 1;
      Delete(SubDataString, 1, Pos(':', SubDataString));
      LoaderMobClass := TSwitch;
      case Id of
        0: LoaderMobClass := TSwitch;
        1: LoaderMobClass := TSignalPulse;
        2: LoaderMobClass := TLED;
        3: LoaderMobClass := TNot;
        4: LoaderMobClass := TNand;
        5: LoaderMobClass := TNor;
        6: LoaderMobClass := TAnd;
        7: LoaderMobClass := TOr;
        8: LoaderMobClass := TXor;
        9: LoaderMobClass := TOneBitFullAdder;
        10: LoaderMobClass := TFlipFlop;
        11: LoaderMobClass := T41Multiplexer;
        12: LoaderMobClass := TFourBitFullAdder;
        13: LoaderMobClass := T4bRAM;
      end;
      Mobs.insertItem(LoaderMobClass.loadFromString(SubDataString, BackgroundImg.Canvas));
    end;
  CurrentId := MaxId;
  while PLDataString <> '' do
    begin
      if Pos(';', PLDataString) > 0 then
        EndOfSection := Pos(';', PLDataString)
      else
        begin
          PLDataString := PLDataString + ';';
          EndOfSection := Length(PLDataString);
        end;
      SubDataString := Copy(PLDataString, 1, EndOfSection - 1);
      Delete(PLDataString, 1, EndOfSection);
      S := Mobs.getByValue(StrToInt(Copy(SubDataString, 1, Pos(':', SubDataString) - 1))) as TGate;
      Delete(SubDataString, 1, Pos(':', SubDataString));
      NS := StrToInt(Copy(SubDataString, 1, Pos(':', SubDataString) - 1));
      Delete(SubDataString, 1, Pos(':', SubDataString));
      D := Mobs.getByValue(StrToInt(Copy(SubDataString, 1, Pos(':', SubDataString) - 1))) as TGate;
      Delete(SubDataString, 1, Pos(':', SubDataString));
      ND := StrToInt(Copy(SubDataString, 1, Pos(':', SubDataString) - 1));
      Delete(SubDataString, 1, Pos(':', SubDataString));
      Value := false;
      if SubDataString = '1' then
        Value := true;
      PowerLines.insertItem(TPowerLine.softCreate(NS, S, ND, D, Value, BackgroundImg.Canvas, getNextId(), Queue, PowerLines));
    end;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
  AboutBox.show;
end;

procedure TForm1.Bedienung1Click(Sender: TObject);
begin
  OKBottomDlg.Show;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  Reg : TRegistry;
begin
  // Check, if we ever ran before.
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Not(Reg.OpenKey('\Software\Dizzy\Shown', false)) then
      begin
        AboutBox.Show;
      end;
  finally
    Reg.Free;
  end;
  Timer2.Destroy;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
var
  Tree : TTree;
  Mob : TGate;
begin
  Tree := Queue.getCurrent as TTree;
  Queue.insertItem(TTree.Create(TGate, getMValue));
  Queue.deleteItem;
  Queue.resetPosition;
  Mob := Tree.resetPosition as TGate;
  while Mob <> nil do
    begin
      Mob.signalChanged;
      Mob.blitToCanvas;
      Mob := Tree.getNext as TGate;
    end;
end;

procedure TForm1.Button16Click(Sender: TObject);
var
  p : TPowerLine;
begin
  Quick := Not(Quick);
  PowerLines.resetPosition;
  p := PowerLines.getNext as TPowerLine;
  while p <> nil do
    begin
      p.changeQuick(Quick);
      p := PowerLines.getNext as TPowerLine;
    end;
  Timer3.Enabled := Not(Quick);
end;

end.
